%% intra weight for each site
function IntraWeight = IntraWeightforPairwiseScore(protein,  stats, temppath, EBindex)
% if we also try to modify the score for each site in a particular patch
EBPCC = stats.neighborhood_intra{3};
% find the residue numbers for the scores
length = protein.aln.nogap.length;
IntraWeight =  eye(length, length);
clear tempdata;
tempdata = load([temppath, 'NeighborInfo', protein.names, '.mat']);
neighborLocationForColumn = tempdata.neighborLocationForColumn;
clear tempdata;
aminonames = {'R', 'N', 'D', 'C', 'Q', 'E', 'G', 'H', 'I', 'L', 'K', 'M', 'F', 'P', 'S', 'T', 'W', 'Y', 'V', 'A'};
alignment = protein.aln.nogap.seq;
proteinname = protein.names;
num_seq = size(alignment,1);
num_column = size(alignment(1,1).Sequence, 2);
mapped_index = -1 * ones(num_seq, num_column);
fiddata = fopen([temppath, 'IndexMSA', proteinname,'.mat']);
if fiddata == -1    
    for i = 1 : num_seq
        for j = 1 : num_column
            mapped_index(i,j) = MapResiduesToIndex(alignment(i,1).Sequence(j), aminonames);
        end
    end
    save([temppath, 'IndexMSA', proteinname,'.mat'], 'mapped_index');
else
    fclose(fiddata);
    clear tempdata;
    tempdata = load([temppath, 'IndexMSA', proteinname,'.mat']);
    mapped_index = tempdata.mapped_index;
    clear tempdata;    
end 
for i = 1 : length
    for j = 2 : size(neighborLocationForColumn{i},2)
        summ = 0; count = 0;
        for k = 1 : size(mapped_index,1)
            if mapped_index(k,i) > 0 && mapped_index(k,neighborLocationForColumn{i}(j)) > 0
                summ = summ + EBPCC(mapped_index(k,i), mapped_index(k,neighborLocationForColumn{i}(j)));
                count = count + 1;
            end            
        end
        if count > 0
            IntraWeight(i,neighborLocationForColumn{i}(j)) = summ / count / size(neighborLocationForColumn{i},2);
        end
    end
    IntraWeight(i,i) = 1 / size(neighborLocationForColumn{i},2);
end 


%% if one residue has no structure information in the target protein, it's
%% intradomain weight would be the average of the whole weight matrix
% average weight in the w-matrix
averageweight = 0;
count = 0; % how many sites with str. info.
for i = 1 : length
    if EBindex(i) > 0
        count = count + 1; 
        count1 = 0; % how many neighbors
        summ1 = 0;
        for j = 1 : length
            if IntraWeight(i,j) > 0
                summ1 = summ1 + IntraWeight(i,j);
                count1 = count1 + 1;
            end
        end
        if count1 > 0
            averageweight = averageweight + summ1 / count1;        
        end
    end
end
if count > 0
    averageweight = averageweight / count;
end
% find the target sequence
clear target_sequence;
target_sequence = find_sequence(protein.aln.seq, protein.gi_number); 
for i = 1 : length
    if EBindex(i) == 0 % no structure info.
        if target_sequence(i) > 0 % aa index -1 means there is a space; otherwise, it is an aa
            IntraWeight(i,i) = averageweight;
        end
    end
end











