%% delete GAPs
% input: aln file, threshold_gaps = 0.1
% gap > 10% delete column;
% output: aln_nogaps file
function data_nogap = delete_gaps(aln1, aln2, threshold_gaps)

[mHea1, mSeq1] = fastaread(aln1);

if ~iscell(mSeq1)
    mSeq{1} = mSeq1;
    mHea{1} = mHea1;
else
    mSeq = mSeq1;
    mHea = mHea1;
end

nSeq = size(mSeq{1,1},2);
n = size(mSeq,2);

GAP = threshold_gaps;
% Identity = threshold_redundancy;

left_column_vector = deleGap(mSeq, n, nSeq, GAP);
for i = 1 : n
    data_nogap(i,1).Sequence = mSeq{i}(1,left_column_vector);
    data_nogap(i,1).Header = mHea{i};
    
end
save([aln2,'_loc.mat'],'left_column_vector');

fastawrite(aln2, data_nogap);


function left_column_vector = deleGap(seq, n, nSeq, percent)
left_column_vector = [];
for i = 1 : nSeq
    count = 0;
    for j = 1 : n
        if seq{j}(1,i) == '-' || seq{j}(1,i) == '.'
            count = count + 1;
        end
    end
    if count / n < percent
        left_column_vector = [left_column_vector, i];
    end
end

         
function left_row_vector = deleSeq (seq, n, percent)
left_row_vector = [1];
for i = 2 : n
    key = 0;
    for j = 1 : size(left_row_vector,2)
        if identity(seq{i},seq{left_row_vector(1,j)}) > percent
            key = 1;
            break;
        end        
    end
    if key == 0
       left_row_vector = [left_row_vector,i];
    end        
end

function iden = identity(seq1,seq2)
count = 0;
n = size(seq1,2);
for i = 1 : n
    if seq1(1,i) == seq2(1,i)
        count = count + 1;
    end
end
iden =  count / n;
        
