%%randomize pairs of CheA and CheW at the separete_site in the fasta and
%%write another fasta named filename_randomized.aln
% !!please note that: I have not change the CheWs' ID with their
% sequences!! that's to say the id part of these sequences will stay the
% same as before
function protein1 = randomizePairing(protein)

seperate_site = protein.aln.nogap.seprate_site;
filename = protein.infile;
filename2 = protein.infile_randomized;

%% multi sequence alignment  A + B
data = fastaread(filename);
%separete the two sequences
n = size(data,1);
ref_id = 0;
for i = 1 : n
    seq0 = data(i).Sequence;
    if strcmpi(data(i).Header,protein.gi_number)
        ref_id = i;
    end
    seq1{i} = seq0(1,1:seperate_site);
    seq2{i} = seq0(1,seperate_site+1:size(seq0,2));
end
if ref_id == 0
    'no reference sequence in the MSA !!!!!'
    pause();
end
%randomized match a new pairs of those two sequences
randomized_index =  randperm(n);
for i = 1 : n
    new_data(i,1).Sequence = [seq1{i}, seq2{randomized_index(i)}]; 
    new_data(i,1).Header = data(i).Header;
end
% remain the reference sequence
new_data(1,1).Header = data(ref_id).Header;
new_data(1,1).Sequence = data(ref_id).Sequence;
% write the file
fastawrite(filename2, new_data);
protein1 = protein;
protein1.aln.nogap.randomseq = new_data;



