function predictions = toppredictions_byscorecutoff(scorecutoff, result, scoreID)
%% output the topN predictions in order by the residue numbers
topprediction = zeros(size(result.sitescores{scoreID}{1}));
for i = 1 : size(topprediction,2)
    if result.sitescores{scoreID}{1}(i) > scorecutoff
         topprediction(i) = result.sitescores{scoreID}{1}(i);
    end
end
[X,XI] = sort(topprediction);
location = [];
for i = 1 : size(X,2)
    if X(i) > 0
        location = [location, XI(i)];
    end
end
locationMSA = result.protein.aln.nogap.locationMSA;
residue = result.protein.aln.nogap.residue;
predictions = get_resnum_from_locationMSA(locationMSA, residue, location);
predictions.scores = result.sitescores{scoreID}{1}(location);
predictions.absEntropy = result.protein.aln.nogap.absEntropy(location);
